
package{

	import flash.display.*;
	import flash.events.*;

	[SWF(width="640",height="480")]
	
	public class MonkeyGame extends Sprite{
	
		public function MonkeyGame(){
		
			addEventListener( Event.ADDED_TO_STAGE,OnAddedToStage );
		}
		
		private function OnAddedToStage( e:Event ):void{
		
			BBMonkeyGame.Main( this );
		}
	}
}

final class Config{
//${CONFIG_BEGIN}
internal static var BINARY_FILES:String="*.bin|*.dat"
internal static var BRL_GAMETARGET_IMPLEMENTED:String="1"
internal static var BRL_THREAD_IMPLEMENTED:String="1"
internal static var CD:String=""
internal static var CONFIG:String="release"
internal static var FLASH_RENDER_WHILE_SUSPENDED:String="0"
internal static var HOST:String="winnt"
internal static var IMAGE_FILES:String="*.png|*.jpg"
internal static var LANG:String="as"
internal static var MODPATH:String=""
internal static var MOJO_AUTO_SUSPEND_ENABLED:String="1"
internal static var MOJO_DRIVER_IMPLEMENTED:String="1"
internal static var MOJO_IMAGE_FILTERING_ENABLED:String="1"
internal static var MUSIC_FILES:String="*.mp3"
internal static var SAFEMODE:String="0"
internal static var SOUND_FILES:String="*.mp3"
internal static var TARGET:String="flash"
internal static var TEXT_FILES:String="*.txt|*.xml|*.json"
//${CONFIG_END}
}

final class Assets{
//${ASSETS_BEGIN}
[Embed(source="data/mojo_font.png")]
public static var _9mojo_font3png:Class;
//${ASSETS_END}
}

//${TRANSCODE_BEGIN}

// Actionscript Monkey runtime.
//
// Placed into the public domain 24/02/2011.
// No warranty implied; use at your own risk.

//***** ActionScript Runtime *****

import flash.display.*;
import flash.external.ExternalInterface;

//Consts for radians<->degrees conversions
var D2R:Number=0.017453292519943295;
var R2D:Number=57.29577951308232;

//private
var _errInfo:String="?<?>";
var _errStack:Array=[];

var dbg_index:int=0;

function pushErr():void{
	_errStack.push( _errInfo );
}

function popErr():void{
	_errInfo=_errStack.pop();
}

function stackTrace():String{
	if( !_errInfo.length ) return "";
	var str:String=_errInfo+"\n";
	for( var i:int=_errStack.length-1;i>0;--i ){
		str+=_errStack[i]+"\n";
	}
	return str;
}

function print( str:String ):int{
	try{
		if( ExternalInterface.available ) ExternalInterface.call( "monkey_print",str );
	}catch( ex:Error ){
	}
	return 0;
}

function error( err:String ):int{
	throw err;
}

function debugLog( str:String ):int{
	print( str );
	return 0;
}

function debugStop():int{
	error( "STOP" );
	return 0;
}

function dbg_object( obj:Object ):Object{
	if( obj ) return obj;
	error( "Null object access" );
	return obj;
}

function dbg_array( arr:Array,index:int ):Array{
	if( index<0 || index>=arr.length ) error( "Array index out of range" );
	dbg_index=index;
	return arr;
}

function dbg_charCodeAt( str:String,index:int ):int{
	if( index<0 || index>=str.length ) error( "Character index out of range" );
	return str.charCodeAt( index );
}

function new_bool_array( len:int ):Array{
	var arr:Array=new Array( len )
	for( var i:int=0;i<len;++i ) arr[i]=false;
	return arr;
}

function new_number_array( len:int ):Array{
	var arr:Array=new Array( len )
	for( var i:int=0;i<len;++i ) arr[i]=0;
	return arr;
}

function new_string_array( len:int ):Array{
	var arr:Array=new Array( len );
	for( var i:int=0;i<len;++i ) arr[i]='';
	return arr;
}

function new_array_array( len:int ):Array{
	var arr:Array=new Array( len );
	for( var i:int=0;i<len;++i ) arr[i]=[];
	return arr;
}

function new_object_array( len:int ):Array{
	var arr:Array=new Array( len );
	for( var i:int=0;i<len;++i ) arr[i]=null;
	return arr;
}

function resize_bool_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=false;
	return arr;
}

function resize_number_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=0;
	return arr;
}

function resize_string_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]="";
	return arr;
}

function resize_array_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=[];
	return arr;
}

function resize_object_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=null;
	return arr;
}

function string_compare( lhs:String,rhs:String ):int{
	var n:int=Math.min( lhs.length,rhs.length ),i:int,t:int;
	for( i=0;i<n;++i ){
		t=lhs.charCodeAt(i)-rhs.charCodeAt(i);
		if( t ) return t;
	}
	return lhs.length-rhs.length;
}

function string_replace( str:String,find:String,rep:String ):String{	//no unregex replace all?!?
	var i:int=0;
	for(;;){
		i=str.indexOf( find,i );
		if( i==-1 ) return str;
		str=str.substring( 0,i )+rep+str.substring( i+find.length );
		i+=rep.length;
	}
	return str;
}

function string_trim( str:String ):String{
	var i:int=0,i2:int=str.length;
	while( i<i2 && str.charCodeAt(i)<=32 ) i+=1;
	while( i2>i && str.charCodeAt(i2-1)<=32 ) i2-=1;
	return str.slice( i,i2 );
}

function string_tochars( str:String ):Array{
	var arr:Array=new Array( str.length );
	for( var i:int=0;i<str.length;++i ) arr[i]=str.charCodeAt(i);
	return arr;	
}

function string_startswith( str:String,sub:String ):Boolean{
	return sub.length<=str.length && str.slice(0,sub.length)==sub;
}

function string_endswith( str:String,sub:String ):Boolean{
	return sub.length<=str.length && str.slice(str.length-sub.length,str.length)==sub;
}

function string_fromchars( chars:Array ):String{
	var str:String="",i:int;
	for( i=0;i<chars.length;++i ){
		str+=String.fromCharCode( chars[i] );
	}
	return str;
}

class ThrowableObject{
	internal function toString():String{
		return "Uncaught Monkey Exception";
	}
}


import flash.display.*;
import flash.events.*;
import flash.media.*;
import flash.net.*;
import flash.utils.ByteArray;

import flash.ui.*;

class BBGameEvent{
	public static const KeyDown:int=1;
	public static const KeyUp:int=2;
	public static const KeyChar:int=3;
	public static const MouseDown:int=4;
	public static const MouseUp:int=5;
	public static const MouseMove:int=6;
	public static const TouchDown:int=7;
	public static const TouchUp:int=8;
	public static const TouchMove:int=9;
	public static const MotionAccel:int=10;
}

class BBGameDelegate{
	public function StartGame():void{}
	public function SuspendGame():void{}
	public function ResumeGame():void{}
	public function UpdateGame():void{}
	public function RenderGame():void{}
	public function KeyEvent( event:int,data:int ):void{}
	public function MouseEvent( event:int,data:int,x:Number,y:Number ):void{}
	public function TouchEvent( event:int,data:int,x:Number,y:Number ):void{}
	public function MotionEvent( event:int,data:int,x:Number,y:Number,z:Number ):void{}
	public function DiscardGraphics():void{}
}

class BBDisplayMode{
	public var width:int;
	public var height:int;
}

class BBGame{

	internal static var _game:BBGame;

	internal var _delegate:BBGameDelegate;
	internal var _keyboardEnabled:Boolean;
	internal var _updateRate:int;
	internal var _debugExs:Boolean;
	internal var _started:Boolean;
	internal var _suspended:Boolean;
	internal var _startms:Number;
	
	public function BBGame(){
		_game=this;
		_debugExs=(Config.CONFIG=="debug");
		_startms=(new Date).getTime();
	}
	
	public static function Game():BBGame{
		return _game;
	}
	
	public function SetDelegate( delegate:BBGameDelegate ):void{
		_delegate=delegate;
	}
	
	public function Delegate():BBGameDelegate{
		return _delegate;
	}
	
	public function SetKeyboardEnabled( enabled:Boolean ):void{
		_keyboardEnabled=enabled;
	}
	
	public function SetUpdateRate( hertz:int ):void{
		_updateRate=hertz;
	}
	
	public function Started():Boolean{
		return _started;
	}
	
	public function Suspended():Boolean{
		return _suspended;
	}
	
	public function Millisecs():int{
		return (new Date).getTime()-_startms;
	}
	
	public function GetDate( date:Array ):void{
		var n:int=date.length;
		if( n>0 ){
			var t:Date=new Date();
			date[0]=t.getFullYear();
			if( n>1 ){
				date[1]=t.getMonth()+1;
				if( n>2 ){
					date[2]=t.getDate();
					if( n>3 ){
						date[3]=t.getHours();
						if( n>4 ){
							date[4]=t.getMinutes();
							if( n>5 ){
								date[5]=t.getSeconds();
								if( n>6 ){
									date[6]=t.getMilliseconds();
								}
							}
						}
					}
				}
			}
		}
	}
	
	public function SaveState( state:String ):int{
		var file:SharedObject=SharedObject.getLocal( "monkeystate" );
		file.data.state=state;
		file.close();
		return 0;
	}
	
	public function LoadState():String{
		var file:SharedObject=SharedObject.getLocal( "monkeystate" );
		var state:String=file.data.state;
		file.close();
		if( state ) return state;
		return "";
	}

	public function LoadString( path:String ):String{
		var buf:ByteArray=LoadData( path );
		if( buf ) return buf.toString();
		return "";
	}
	
	public function PollJoystick( port:int,joyx:Array,joyy:Array,joyz:Array,buttons:Array ):Boolean{
		return false;
	}
	
	public function OpenUrl( url:String ):void{
		navigateToURL( new URLRequest( url ) );
	}
	
	public function SetMouseVisible( visible:Boolean ):void{
		if( visible ){
			Mouse.show();
		}else{
			Mouse.hide();
		}
	}
	
	public function GetDeviceWidth():int{
		return 0;
	}
	
	public function GetDeviceHeight():int{
		return 0;
	}
	
	public function SetDeviceWindow( width:int,height:int,flags:int ):void{
	}
	
	public function GetDisplayModes():Array{
		return new Array();
	}
	
	public function GetDesktopMode():BBDisplayMode{
		return null;
	}
	
	public function SetSwapInterval( interval:int ):void{
	}
	
	public function PathToFilePath( path:String ):String{
		return "";
	}
	
	//***** Flash Game *****
	
	public function PathToUrl( path:String ):String{
		return path;
	}
	
	public function LoadData( path:String ):ByteArray{
		//TODO: Load from URL
		return null;
	}
	
	//***** INTERNAL *****
	public function Die( ex:Object ):void{
	
		_delegate=new BBGameDelegate();
		
		if( !ex.toString() ){
			return;
		}
		if( _debugExs ){
			print( "Monkey Runtime Error : "+ex.toString() );
			print( stackTrace() );
		}
		throw ex;
	}
	
	public function StartGame():void{
	
		if( _started ) return;
		_started=true;
		
		try{
			_delegate.StartGame();
		}catch( ex:Object ){
			Die( ex );
		}
	}
	
	public function SuspendGame():void{
	
		if( !_started || _suspended ) return;
		_suspended=true;
		
		try{
			_delegate.SuspendGame();
		}catch( ex:Object ){
			Die( ex );
		}
	}
	
	public function ResumeGame():void{

		if( !_started || !_suspended ) return;
		_suspended=false;
		
		try{
			_delegate.ResumeGame();
		}catch( ex:Object ){
			Die( ex );
		}
	}
	
	public function UpdateGame():void{

		if( !_started || _suspended ) return;
		
		try{
			_delegate.UpdateGame();
		}catch( ex:Object ){
			Die( ex );
		}
	}
	
	public function RenderGame():void{

		if( !_started ) return;
		
		try{
			_delegate.RenderGame();
		}catch( ex:Object ){
			Die( ex );
		}
	}
	
	public function KeyEvent( ev:int,data:int ):void{

		if( !_started ) return;
		
		try{
			_delegate.KeyEvent( ev,data );
		}catch( ex:Object ){
			Die( ex );
		}
	}
	
	public function MouseEvent( ev:int,data:int,x:Number,y:Number ):void{

		if( !_started ) return;
		
		try{
			_delegate.MouseEvent( ev,data,x,y );
		}catch( ex:Object ){
			Die( ex );
		}
	}
	
	public function TouchEvent( ev:int,data:int,x:Number,y:Number ):void{

		if( !_started ) return;
		
		try{
			_delegate.TouchEvent( ev,data,x,y );
		}catch( ex:Object ){
			Die( ex );
		}
	}
	
	public function MotionEvent( ev:int,data:int,x:Number,y:Number,z:Number ):void{

		if( !_started ) return;
		
		try{
			_delegate.MotionEvent( ev,data,x,y,z );
		}catch( ex:Object ){
			Die( ex );
		}
	}
	
	public function DiscardGraphics():void{

		if( !_started ) return;
		
		try{
			_delegate.DiscardGraphics();
		}catch( ex:Object ){
			Die( ex );
		}
	}
}


class BBFlashGame extends BBGame{

	internal static var _flashGame:BBFlashGame;
	
	internal var _root:DisplayObjectContainer;
	
	internal var _nextUpdate:Number;
	internal var _updatePeriod:Number;

	public function BBFlashGame( root:DisplayObjectContainer ){
		_flashGame=this;
		_root=root;
	}
	
	public static function FlashGame():BBFlashGame{
		return _flashGame;
	}
	
	internal function KeyToChar( key:int ):int{
		switch( key ){
		case 8:case 9:case 13:case 27:return key;
		case 33:case 34:case 35:case 36:case 37:case 38:case 39:case 40:case 45:return key | 0x10000;
		case 46:return 127;
		}
		return 0;
	}
	
	internal function ValidateUpdateTimer():void{
		if( _suspended ){
			_root.stage.frameRate=24;
		}else if( _updateRate ){
			_updatePeriod=1000.0/_updateRate;
			_nextUpdate=0;
			_root.stage.frameRate=_updateRate;
		}else{
			_root.stage.frameRate=60;
		}
	}
	
	//***** BBGame *****	
	
	public override function GetDeviceWidth():int{
		return _root.stage.stageWidth;
	}
	
	public override function GetDeviceHeight():int{
		return _root.stage.stageHeight;
	}
	
	public override function SetUpdateRate( hertz:int ):void{
		super.SetUpdateRate( hertz );
		ValidateUpdateTimer();
	}
	
	public override function PathToUrl( path:String ):String {
		if( path.indexOf( "monkey:" )!=0 ){
			return path;
		}else if( path.indexOf( "monkey://data/" )==0 ){
			return "data/"+path.slice( 14 );
		}
		return "";
	}

	public override function LoadData( path:String ):ByteArray{
		var t:Class=GetAsset( path );
		if( t ) return (new t) as ByteArray;
		return null;
	}

	public function GetDisplayObjectContainer():DisplayObjectContainer{
		return _root;
	}

	public function GetAsset( path:String ):Class{
		if( path.indexOf( "monkey://data/" )!=0 ) return null;

		path=path.slice(14);
		
		var i:int=path.indexOf( "." ),ext:String="";
		if( i!=-1 ){
			ext=path.slice(i+1);
			path=path.slice(0,i);
		}

		var munged:String="_";
		var bits:Array=path.split( "/" );
		
		for( i=0;i<bits.length;++i ){
			munged+=bits[i].length+bits[i];
		}
		munged+=ext.length+ext;
		
		return Assets[munged];
	}
	
	public function LoadBitmap( path:String ):Bitmap{
		var t:Class=GetAsset( path );
		if( t ) return (new t) as Bitmap;
		return null;
	}
	
	public function LoadSound( path:String ):Sound{
		var t:Class=GetAsset( path );
		if( t ) return (new t) as Sound;
		return null;
	}
	
	//***** INTERNAL *****
	
	public override function SuspendGame():void{
		super.SuspendGame();
		super.RenderGame();
		ValidateUpdateTimer();
	}
	
	public override function ResumeGame():void{
		super.ResumeGame();
		ValidateUpdateTimer();
	}

	public function Run():void{

		_root.stage.addEventListener( Event.ACTIVATE,OnActivate );
		_root.stage.addEventListener( Event.DEACTIVATE,OnDeactivate );
		_root.stage.addEventListener( Event.ENTER_FRAME,OnEnterFrame );
		_root.stage.addEventListener( KeyboardEvent.KEY_DOWN,OnKeyDown );
		_root.stage.addEventListener( KeyboardEvent.KEY_UP,OnKeyUp );
		_root.stage.addEventListener( flash.events.MouseEvent.MOUSE_DOWN,OnMouseDown );
		_root.stage.addEventListener( flash.events.MouseEvent.MOUSE_UP,OnMouseUp );
		_root.stage.addEventListener( flash.events.MouseEvent.MOUSE_MOVE,OnMouseMove );
		
		StartGame();
	}

	public function OnActivate( e:Event ):void{
		if( Config.MOJO_AUTO_SUSPEND_ENABLED=="1" ) ResumeGame();
	}
	
	public function OnDeactivate( e:Event ):void{
		if( Config.MOJO_AUTO_SUSPEND_ENABLED=="1" ) SuspendGame();
	}
	
	public function OnEnterFrame( e:Event ):void{
		if( _suspended ){
			if( Config.FLASH_RENDER_WHILE_SUSPENDED=="1" ) RenderGame();
			return;
		}
		
		if( !_updateRate ){
			UpdateGame();
			RenderGame();
			return;
		}
		
		if( !_nextUpdate ) _nextUpdate=(new Date).getTime();
		
		var i:int;
		for( i=0;i<4;++i ){
		
			UpdateGame();
			if( !_nextUpdate ) break;
			
			_nextUpdate+=_updatePeriod;
			if( (new Date).getTime()<_nextUpdate ) break;
		}
		if( i==4 ) _nextUpdate=0;
		RenderGame();
	}
	
	public function OnKeyDown( e:KeyboardEvent ):void{
		KeyEvent( BBGameEvent.KeyDown,e.keyCode );
		if( e.charCode!=0 ){
			KeyEvent( BBGameEvent.KeyChar,e.charCode );
		}else{
			var chr:int=KeyToChar( e.keyCode );
			if( chr ) KeyEvent( BBGameEvent.KeyChar,chr );
		}
	}

	public function OnKeyUp( e:KeyboardEvent ):void{
		KeyEvent( BBGameEvent.KeyUp,e.keyCode );
	}
		
	public function OnMouseDown( e:flash.events.MouseEvent ):void{
		MouseEvent( BBGameEvent.MouseDown,0,e.localX,e.localY );
	}
		
	public function OnMouseUp( e:flash.events.MouseEvent ):void{
		MouseEvent( BBGameEvent.MouseUp,0,e.localX,e.localY );
	}

	public function OnMouseMove( e:flash.events.MouseEvent ):void{
		MouseEvent( BBGameEvent.MouseMove,-1,e.localX,e.localY );
	}

}


class BBMonkeyGame extends BBFlashGame{

	internal static var _monkeyGame:BBMonkeyGame;
	
	public function BBMonkeyGame( root:DisplayObjectContainer ){
		super( root );
	}
	
	public static function Main( root:DisplayObjectContainer ):void{
		
		_monkeyGame=new BBMonkeyGame( root );

		try{
		
			bbInit();
			bbMain();
			
		}catch( ex:Object ){
		
			_monkeyGame.Die( ex );
			return;
		}
		
		if( !_monkeyGame.Delegate() ) return;
		
		_monkeyGame.Run();
	}
}


// Flash mojo runtime.
//
// Copyright 2011 Mark Sibly, all rights reserved.
// No warranty implied; use at your own risk.

import flash.display.*;
import flash.events.*;
import flash.media.*;
import flash.geom.*;
import flash.utils.*;
import flash.net.*;

class gxtkGraphics{

	internal var game:BBFlashGame;
	internal var stage:Stage;

	internal var bitmap:Bitmap;
	
	internal var red:Number=255;
	internal var green:Number=255;
	internal var blue:Number=255;
	internal var alpha:Number=1;
	internal var colorARGB:uint=0xffffffff;
	internal var colorTform:ColorTransform=null;
	internal var alphaTform:ColorTransform=null;
	
	internal var matrix:Matrix;
	internal var rectBMData:BitmapData;
	internal var blend:String;
	internal var clipRect:Rectangle;
	
	internal var shape:Shape;
	internal var graphics:Graphics;
	internal var bitmapData:BitmapData;
	
	internal var graphics_dirty:Boolean;

	internal var pointMat:Matrix=new Matrix;
	internal var rectMat:Matrix=new Matrix;
	internal var imageMat:Matrix=new Matrix;
	internal var pointCoords:Point=new Point;
	
	internal var image_filtering_enabled:Boolean;
	
	function gxtkGraphics(){

		game=BBFlashGame.FlashGame();
		stage=game.GetDisplayObjectContainer().stage;
		
		image_filtering_enabled=(Config.MOJO_IMAGE_FILTERING_ENABLED=="1");
		
		bitmap=new Bitmap();
		bitmap.bitmapData=new BitmapData( stage.stageWidth,stage.stageHeight,false,0xff0000ff );
		bitmap.smoothing=image_filtering_enabled;
		bitmap.width=stage.stageWidth;
		bitmap.height=stage.stageHeight;
		
		game.GetDisplayObjectContainer().addChild( bitmap );

		shape=new Shape;
		graphics=shape.graphics;
		bitmapData=bitmap.bitmapData;
	
		stage.addEventListener( Event.RESIZE,OnResize );
	
		rectBMData=new BitmapData( 1,1,false,0xffffffff );
		
		image_filtering_enabled=(Config.MOJO_IMAGE_FILTERING_ENABLED=="1");
	}
	
	internal function OnResize( e:Event ):void{
		var w:int=stage.stageWidth;
		var h:int=stage.stageHeight;
		if( w==bitmap.width && h==bitmap.height ) return;
		bitmap.bitmapData=new BitmapData( w,h,false,0xff0000ff );
		bitmap.width=w;
		bitmap.height=h;
	}

	internal function BeginRender():int{
		return 1;
	}

	internal function UseGraphics():void{
		if( graphics_dirty && alphaTform ){
			bitmapData.draw( shape,matrix,alphaTform,blend,clipRect,false );
			graphics.clear();
			return;
		}
		graphics_dirty=true;
	}

	internal function FlushGraphics():void{
		if( graphics_dirty ){
			graphics_dirty=false;
			bitmapData.draw( shape,matrix,alphaTform,blend,clipRect,false );
			graphics.clear();
		}
	}
	
	internal function EndRender():void{
		FlushGraphics();
	}
	
	internal function DiscardGraphics():void{
	}
	
	internal function updateColor():void{
	
		colorARGB=(int(alpha*255)<<24)|(int(red)<<16)|(int(green)<<8)|int(blue);
		
		if( colorARGB==0xffffffff ){
			colorTform=null;
			alphaTform=null;
		}else{
			colorTform=new ColorTransform( red/255.0,green/255.0,blue/255.0,alpha );
			if( alpha==1 ){
				alphaTform=null;
			}else{
				alphaTform=new ColorTransform( 1,1,1,alpha );
			}
		}
	}

	//***** GXTK API *****

	public function Width():int{
		return bitmap.width;
	}

	public function Height():int{
		return bitmap.height;
	}
	
	public function LoadSurface__UNSAFE__( surface:gxtkSurface,path:String ):Boolean{
		return false;
	}

	public function LoadSurface( path:String ):gxtkSurface{
		var bitmap:Bitmap=game.LoadBitmap( path );
		if( bitmap==null ) return null;
		return new gxtkSurface( bitmap );
	}
	
	public function CreateSurface( width:int,height:int ):gxtkSurface{
		var bitmapData:BitmapData=new BitmapData( width,height,true,0 );
		var bitmap:Bitmap=new Bitmap( bitmapData );
		return new gxtkSurface( bitmap );
	}
	
	public function SetAlpha( a:Number ):int{
		FlushGraphics();

		alpha=a;

		updateColor();

		return 0;
	}
	
	public function SetColor( r:Number,g:Number,b:Number ):int{
		FlushGraphics();
		
		red=r;
		green=g;
		blue=b;
	
		updateColor();
		
		return 0;
	}
	
	public function SetBlend( blend:int ):int{
		switch( blend ){
		case 1:
			this.blend=BlendMode.ADD;
			break;
		default:
			this.blend=null;
		}
		return 0;
	}
	
	public function SetScissor( x:int,y:int,w:int,h:int ):int{
		FlushGraphics();
		
		if( x!=0 || y!=0 || w!=bitmap.width || h!=bitmap.height ){
			clipRect=new Rectangle( x,y,w,h );
		}else{
			clipRect=null;
		}
		return 0;
	}

	public function SetMatrix( ix:Number,iy:Number,jx:Number,jy:Number,tx:Number,ty:Number ):int{
		FlushGraphics();
		
		if( ix!=1 || iy!=0 || jx!=0 || jy!=1 || tx!=0 || ty!=0 ){
			matrix=new Matrix( ix,iy,jx,jy,tx,ty );
		}else{
			matrix=null;
		}
		return 0;
	}

	public function Cls( r:Number,g:Number,b:Number ):int{
		FlushGraphics();

		var clsColor:uint=0xff000000|(int(r)<<16)|(int(g)<<8)|int(b);
		var rect:Rectangle=clipRect;
		if( !rect ) rect=new Rectangle( 0,0,bitmap.width,bitmap.height );
		bitmapData.fillRect( rect,clsColor );
		return 0;
	}
	
	public function DrawPoint( x:Number,y:Number ):int{
		FlushGraphics();
		
		if( matrix ){
			var px:Number=x;
			x=px * matrix.a + y * matrix.c + matrix.tx;
			y=px * matrix.b + y * matrix.d + matrix.ty;
		}
		if( clipRect || alphaTform || blend ){
			pointMat.tx=x;pointMat.ty=y;
			bitmapData.draw( rectBMData,pointMat,colorTform,blend,clipRect,false );
		}else{
			bitmapData.fillRect( new Rectangle( x,y,1,1 ),colorARGB );
		}
		return 0;
	}
	
	
	public function DrawRect( x:Number,y:Number,w:Number,h:Number ):int{
		FlushGraphics();
		
		if( matrix ){
			var mat:Matrix=new Matrix( w,0,0,h,x,y );
			mat.concat( matrix );
			bitmapData.draw( rectBMData,mat,colorTform,blend,clipRect,false );
		}else if( clipRect || alphaTform || blend ){
			rectMat.a=w;rectMat.d=h;rectMat.tx=x;rectMat.ty=y;
			bitmapData.draw( rectBMData,rectMat,colorTform,blend,clipRect,false );
		}else{
			bitmapData.fillRect( new Rectangle( x,y,w,h ),colorARGB );
		}
		return 0;
	}

	public function DrawLine( x1:Number,y1:Number,x2:Number,y2:Number ):int{
		
		if( matrix ){
		
			FlushGraphics();
			
			var x1_t:Number=x1 * matrix.a + y1 * matrix.c + matrix.tx;
			var y1_t:Number=x1 * matrix.b + y1 * matrix.d + matrix.ty;
			var x2_t:Number=x2 * matrix.a + y2 * matrix.c + matrix.tx;
			var y2_t:Number=x2 * matrix.b + y2 * matrix.d + matrix.ty;
			
			graphics.lineStyle( 1,colorARGB & 0xffffff );	//why the mask?
			graphics.moveTo( x1_t,y1_t );
			graphics.lineTo( x2_t,y2_t );
			graphics.lineStyle();
			
			bitmapData.draw( shape,null,alphaTform,blend,clipRect,false );
			graphics.clear();
			
		}else{
		
			UseGraphics();

			graphics.lineStyle( 1,colorARGB & 0xffffff );	//why the mask?
			graphics.moveTo( x1,y1 );
			graphics.lineTo( x2,y2 );
			graphics.lineStyle();
		}

		return 0;
 	}

	public function DrawOval( x:Number,y:Number,w:Number,h:Number ):int{
		UseGraphics();

		graphics.beginFill( colorARGB & 0xffffff );			//why the mask?
		graphics.drawEllipse( x,y,w,h );
		graphics.endFill();

		return 0;
	}
	
	public function DrawPoly( verts:Array ):int{
		if( verts.length<2 ) return 0;
		
		UseGraphics();
		
		graphics.beginFill( colorARGB & 0xffffff );			//why the mask?
		
		graphics.moveTo( verts[0],verts[1] );
		for( var i:int=2;i<verts.length;i+=2 ){
			graphics.lineTo( verts[i],verts[i+1] );
		}
		graphics.endFill();
		
		return 0;
	}

	public function DrawPoly2( verts:Array,surface:gxtkSurface,srcx:int,srcy:int ):int{
		if( verts.length<4 ) return 0;
		
		UseGraphics();
		
		graphics.beginFill( colorARGB & 0xffffff );			//why the mask?
		
		graphics.moveTo( verts[0],verts[1] );
		for( var i:int=4;i<verts.length;i+=4 ){
			graphics.lineTo( verts[i],verts[i+1] );
		}
		graphics.endFill();
		
		return 0;
	}

	public function DrawSurface( surface:gxtkSurface,x:Number,y:Number ):int{
		FlushGraphics();
		
		if( matrix ){
			var mat:Matrix=new Matrix( 1,0,0,1,x,y );
			mat.concat( matrix );
			bitmapData.draw( surface.bitmap.bitmapData,mat,colorTform,blend,clipRect,image_filtering_enabled );
		}else if( clipRect || colorTform || blend ){
			imageMat.tx=x;imageMat.ty=y;
			bitmapData.draw( surface.bitmap.bitmapData,imageMat,colorTform,blend,clipRect,image_filtering_enabled );
		}else{
			pointCoords.x=x;pointCoords.y=y;
			bitmapData.copyPixels( surface.bitmap.bitmapData,surface.rect,pointCoords );
		}

		return 0;
	}

	public function DrawSurface2( surface:gxtkSurface,x:Number,y:Number,srcx:int,srcy:int,srcw:int,srch:int ):int{
		if( srcw<0 ){ srcx+=srcw;srcw=-srcw; }
		if( srch<0 ){ srcy+=srch;srch=-srch; }
		if( srcw<=0 || srch<=0 ) return 0;
		
		FlushGraphics();

		var srcrect:Rectangle=new Rectangle( srcx,srcy,srcw,srch );
		
		if( matrix || clipRect || colorTform || blend ){

			var scratch:BitmapData=surface.scratch;
			if( scratch==null || srcw!=scratch.width || srch!=scratch.height ){
				if( scratch!=null ) scratch.dispose();
				scratch=new BitmapData( srcw,srch );
				surface.scratch=scratch;
			}
			pointCoords.x=0;pointCoords.y=0;
			scratch.copyPixels( surface.bitmap.bitmapData,srcrect,pointCoords );
			
			var mat:Matrix;
			if( matrix ){
				mat=new Matrix( 1,0,0,1,x,y );
				mat.concat( matrix );
			}else{
				imageMat.tx=x;imageMat.ty=y;
				mat=imageMat;
			}
			bitmapData.draw( scratch,mat,colorTform,blend,clipRect,image_filtering_enabled );
		}else{
			pointCoords.x=x;pointCoords.y=y;
			bitmapData.copyPixels( surface.bitmap.bitmapData,srcrect,pointCoords );
		}
		return 0;
	}
	
	public function ReadPixels( pixels:Array,x:int,y:int,width:int,height:int,offset:int,pitch:int ):int{
	
		FlushGraphics();
		
		var data:ByteArray=bitmapData.getPixels( new Rectangle( x,y,width,height ) );
		data.position=0;
		
		var px:int,py:int,j:int=offset,argb:int;
		
		for( py=0;py<height;++py ){
			for( px=0;px<width;++px ){
				pixels[j++]=data.readInt();
			}
			j+=pitch-width;
		}
		
		return 0;
	}
	
	public function WritePixels2( surface:gxtkSurface,pixels:Array,x:int,y:int,width:int,height:int,offset:int,pitch:int ):int{

		var data:ByteArray=new ByteArray();
		data.length=width*height;
			
		var px:int,py:int,j:int=offset,argb:int;
		
		for( py=0;py<height;++py ){
			for( px=0;px<width;++px ){
				data.writeInt( pixels[j++] );
			}
			j+=pitch-width;
		}
		data.position=0;
		
		surface.bitmap.bitmapData.setPixels( new Rectangle( x,y,width,height ),data );
		
		return 0;
	}
}

//***** gxtkSurface *****

class gxtkSurface{
	internal var bitmap:Bitmap;
	internal var rect:Rectangle;
	internal var scratch:BitmapData;
	
	function gxtkSurface( bitmap:Bitmap ){
		SetBitmap( bitmap );
	}
	
	public function SetBitmap( bitmap:Bitmap ):void{
		this.bitmap=bitmap;
		rect=new Rectangle( 0,0,bitmap.width,bitmap.height );
	}

	//***** GXTK API *****

	public function Discard():int{
		return 0;
	}
	
	public function Width():int{
		return rect.width;
	}

	public function Height():int{
		return rect.height;
	}

	public function Loaded():int{
		return 1;
	}
	
	public function OnUnsafeLoadComplete():void{
	}
}

class gxtkChannel{
	internal var channel:SoundChannel;	//null then not playing
	internal var sample:gxtkSample;
	internal var loops:Boolean;
	internal var transform:SoundTransform=new SoundTransform();
	internal var pausepos:Number;
	internal var state:int;				//0=stopped, 1=playing, 2=paused, 5=playing/suspended
}

class gxtkAudio{

	internal var busy:Boolean;

	internal var game:BBFlashGame;
	internal var music:gxtkSample;

	internal var channels:Array=new Array( 33 );

	function gxtkAudio(){
		game=BBFlashGame.FlashGame();
		for( var i:int=0;i<33;++i ){
			channels[i]=new gxtkChannel();
		}
	}
	
	internal function SoundComplete( ev:Event ):void{

		//Should never happen!	
		if( busy ){
			debugLog( "gxtkAudio.SoundComplete Error - audio is busy!" );
			return;
		}
		
		busy=true;
		
		for( var i:int=0;i<33;++i ){
			var chan:gxtkChannel=channels[i];
			if( chan.state==1 && chan.channel==ev.target ){
				if( chan.loops ){
					chan.channel=chan.sample.sound.play( 0,0,chan.transform );
					if( chan.channel ){
						chan.channel.addEventListener( Event.SOUND_COMPLETE,SoundComplete );
						continue;
					}
				}
				chan.channel=null;
				chan.sample=null;
				chan.state=0;
			}
		}
		
		busy=false;
	}
	
	//***** GXTK API *****
	
	public function Suspend():int{
	
		busy=true;
		
		for( var i:int=0;i<33;++i ){
			var chan:gxtkChannel=channels[i];
			if( chan.state==1 ){
				chan.pausepos=chan.channel.position;
				chan.channel.stop();
				chan.channel=null;
				chan.state=5;
			}
		}
		
		busy=false;
		
		return 0;
	}
	
	public function Resume():int{
	
		busy=true;
		
		for( var i:int=0;i<33;++i ){
			var chan:gxtkChannel=channels[i];
			if( chan.state==5 ){
				chan.channel=chan.sample.sound.play( chan.pausepos,0,chan.transform );
				if( chan.channel ){
					chan.channel.addEventListener( Event.SOUND_COMPLETE,SoundComplete );
					chan.state=1;
					continue;
				}
				
				debugLog( "gxtkAudio.Resume() - failed to create SoundChannel" );
				
				chan.sample=null;
				chan.state=0;
			}
		}
		
		busy=false;
		
		return 0;
	}
	
	public function LoadSample__UNSAFE__( sample:gxtkSample,path:String ):Boolean{
		return false;
	}
	
	public function LoadSample( path:String ):gxtkSample{
		var sound:Sound=game.LoadSound( path );
		if( sound ) return new gxtkSample( sound );
		return null;
	}
	
	public function PlaySample( sample:gxtkSample,channel:int,flags:int ):int{
		var chan:gxtkChannel=channels[channel];
		
		busy=true;
		
		if( chan.state!=0 ) chan.channel.stop();

		chan.sample=sample;
		chan.loops=(flags & 1)!=0;
		chan.channel=sample.sound.play( 0,0,chan.transform );
		if( chan.channel ){
			chan.channel.addEventListener( Event.SOUND_COMPLETE,SoundComplete );
			chan.state=1;
		}else{
			chan.sample=null;
			chan.state=0;
		}
		
		busy=false;

		return 0;
	}
	
	public function StopChannel( channel:int ):int{
		var chan:gxtkChannel=channels[channel];
		
		busy=true;
		
		if( chan.state!=0 ){
			if( chan.state==1 ){
				chan.channel.stop();
				chan.channel=null;
			}
			chan.sample=null;
			chan.state=0;
		}
		
		busy=false;
		
		return 0;
	}
	
	public function PauseChannel( channel:int ):int{
		var chan:gxtkChannel=channels[channel];
		
		busy=true;
		
		if( chan.state==1 ){
			chan.pausepos=chan.channel.position;
			chan.channel.stop();
			chan.channel=null;
			chan.state=2;
		}
		
		busy=false;
		
		return 0;
	}
	
	public function ResumeChannel( channel:int ):int{
		var chan:gxtkChannel=channels[channel];
		
		busy=true;
		
		if( chan.state==2 ){
			chan.channel=chan.sample.sound.play( chan.pausepos,0,chan.transform );
			if( chan.channel ){
				chan.channel.addEventListener( Event.SOUND_COMPLETE,SoundComplete );
				chan.state=1;
			}else{
				chan.sample=null;
				chan.state=0;
			}
		}
		
		busy=false;
		
		return 0;
	}
	
	public function ChannelState( channel:int ):int{
		var chan:gxtkChannel=channels[channel];
		
		return chan.state & 3;
	}
	
	public function SetVolume( channel:int,volume:Number ):int{
		var chan:gxtkChannel=channels[channel];
		
		chan.transform.volume=volume;

		if( chan.state==1 ) chan.channel.soundTransform=chan.transform;

		return 0;
	}
	
	public function SetPan( channel:int,pan:Number ):int{
		var chan:gxtkChannel=channels[channel];
		
		chan.transform.pan=pan;

		if( chan.state==1 ) chan.channel.soundTransform=chan.transform;

		return 0;
	}
	
	public function SetRate( channel:int,rate:Number ):int{
		return -1;
	}
	
	public function PlayMusic( path:String,flags:int ):int{
		StopMusic();
		
		music=LoadSample( path );
		if( !music ) return -1;
		
		PlaySample( music,32,flags );
		return 0;
	}
	
	public function StopMusic():int{
		StopChannel( 32 );
		
		if( music ){
			music.Discard();
			music=null;
		}
		return 0;
	}
	
	public function PauseMusic():int{
		PauseChannel( 32 );
		
		return 0;
	}
	
	public function ResumeMusic():int{
		ResumeChannel( 32 );
		
		return 0;
	}
	
	public function MusicState():int{
		return ChannelState( 32 );
	}
	
	public function SetMusicVolume( volume:Number ):int{
		SetVolume( 32,volume );
		return 0;
	}
}

class gxtkSample{

	internal var sound:Sound;

	function gxtkSample( sound:Sound ){
		this.sound=sound;
	}
	
	public function Discard():int{
		return 0;
	}
	
}


class BBThread{

	internal var result:Object=null;
	internal var running:Boolean=false;
	
	public function Start():void{
		result=null;
		running=true;
		Run__UNSAFE__();
	}
	
	public function IsRunning():Boolean{
		return running;
	}
	
	public function Result():Object{
		return result;
	}
	
	public function Run__UNSAFE__():void{
		running=false;
	}
}


class BBAsyncImageLoaderThread{

	internal var _running:Boolean=false;
	
	internal var _device:gxtkGraphics;
	internal var _path:String;
	internal var _surface:gxtkSurface;
	internal var _result:Boolean;

	public function Start():void{
		
		var thread:BBAsyncImageLoaderThread=this;
		
		thread._surface=null;
		thread._result=false;
		thread._running=true;
		
		var loader:Loader=new Loader();
		
		loader.contentLoaderInfo.addEventListener( Event.COMPLETE,onLoaded );
		loader.contentLoaderInfo.addEventListener( IOErrorEvent.IO_ERROR,onIoError );
		loader.contentLoaderInfo.addEventListener( SecurityErrorEvent.SECURITY_ERROR,onSecurityError );

		function onLoaded( e:Event ):void{
			thread._surface=new gxtkSurface( e.target.content );
			thread._result=true;
			thread._running=false;
		}
		
		function onIoError( e:IOErrorEvent ):void{
			thread._running=false;
		}

		function onSecurityError( e:SecurityErrorEvent ):void{
			thread._running=false;
		}
		
		loader.load( new URLRequest( BBGame.Game().PathToUrl( thread._path ) ) );
	}
	
	public function IsRunning():Boolean{
		return _running;
	}
}


class BBAsyncSoundLoaderThread{

	internal var _running:Boolean=false;
	
	internal var _device:gxtkAudio;
	internal var _path:String;
	internal var _sample:gxtkSample;
	internal var _result:Boolean;

	public function Start():void{
		
		var thread:BBAsyncSoundLoaderThread=this;
		
		thread._sample=null;
		thread._result=false;
		thread._running=true;
		
		var sound:Sound=new Sound();
		
		sound.addEventListener( Event.COMPLETE,onLoaded );
		sound.addEventListener( IOErrorEvent.IO_ERROR,onIoError );
		sound.addEventListener( SecurityErrorEvent.SECURITY_ERROR,onSecurityError );
		
		function onLoaded( e:Event ):void{
			thread._sample=new gxtkSample( sound );
			thread._running=false;
		}
		
		function onIoError( e:IOErrorEvent ):void{
			thread._sample=null;
			thread._running=false;
		}

		function onSecurityError( e:SecurityErrorEvent ):void{
			thread._sample=null;
			thread._running=false;
		}
		
		sound.load( new URLRequest( BBGame.Game().PathToUrl( thread._path ) ) );
	}
	
	public function IsRunning():Boolean{
		return _running;
	}
}

class c_App extends Object{
	public function m_App_new():c_App{
		if((bb_app__app)!=null){
			error("App has already been created");
		}
		bb_app__app=this;
		bb_app__delegate=(new c_GameDelegate).m_GameDelegate_new();
		bb_app__game.SetDelegate(bb_app__delegate);
		return this;
	}
	public function p_OnResize():int{
		return 0;
	}
	public function p_OnCreate():int{
		return 0;
	}
	public function p_OnSuspend():int{
		return 0;
	}
	public function p_OnResume():int{
		return 0;
	}
	public function p_OnUpdate():int{
		return 0;
	}
	public function p_OnLoading():int{
		return 0;
	}
	public function p_OnRender():int{
		return 0;
	}
	public function p_OnClose():int{
		bb_app_EndApp();
		return 0;
	}
	public function p_OnBack():int{
		this.p_OnClose();
		return 0;
	}
}
class c_MyGame extends c_App{
	public function m_MyGame_new():c_MyGame{
		super.m_App_new();
		return this;
	}
	public override function p_OnCreate():int{
		bb_app_SetUpdateRate(10);
		return 0;
	}
	internal var m_refreshtime:int=0;
	public override function p_OnUpdate():int{
		m_refreshtime+=1;
		if(m_refreshtime>10){
			bb_test1_myhmap=(new c_heightmap).m_heightmap_new(100,100);
			m_refreshtime=0;
		}
		return 0;
	}
	public override function p_OnRender():int{
		bb_graphics_Cls(0.0,0.0,0.0);
		bb_graphics_SetColor(255.0,255.0,255.0);
		bb_test1_myhmap.p_draw();
		return 0;
	}
}
var bb_app__app:c_App;
class c_GameDelegate extends BBGameDelegate{
	public function m_GameDelegate_new():c_GameDelegate{
		return this;
	}
	internal var m__graphics:gxtkGraphics=null;
	internal var m__audio:gxtkAudio=null;
	internal var m__input:c_InputDevice=null;
	public override function StartGame():void{
		m__graphics=(new gxtkGraphics);
		bb_graphics_SetGraphicsDevice(m__graphics);
		bb_graphics_SetFont(null,32);
		m__audio=(new gxtkAudio);
		bb_audio_SetAudioDevice(m__audio);
		m__input=(new c_InputDevice).m_InputDevice_new();
		bb_input_SetInputDevice(m__input);
		bb_app_ValidateDeviceWindow(false);
		bb_app_EnumDisplayModes();
		bb_app__app.p_OnCreate();
	}
	public override function SuspendGame():void{
		bb_app__app.p_OnSuspend();
		m__audio.Suspend();
	}
	public override function ResumeGame():void{
		m__audio.Resume();
		bb_app__app.p_OnResume();
	}
	public override function UpdateGame():void{
		bb_app_ValidateDeviceWindow(true);
		m__input.p_BeginUpdate();
		bb_app__app.p_OnUpdate();
		m__input.p_EndUpdate();
	}
	public override function RenderGame():void{
		bb_app_ValidateDeviceWindow(true);
		var t_mode:int=m__graphics.BeginRender();
		if((t_mode)!=0){
			bb_graphics_BeginRender();
		}
		if(t_mode==2){
			bb_app__app.p_OnLoading();
		}else{
			bb_app__app.p_OnRender();
		}
		if((t_mode)!=0){
			bb_graphics_EndRender();
		}
		m__graphics.EndRender();
	}
	public override function KeyEvent(t_event:int,t_data:int):void{
		m__input.p_KeyEvent(t_event,t_data);
		if(t_event!=1){
			return;
		}
		var t_1:int=t_data;
		if(t_1==432){
			bb_app__app.p_OnClose();
		}else{
			if(t_1==416){
				bb_app__app.p_OnBack();
			}
		}
	}
	public override function MouseEvent(t_event:int,t_data:int,t_x:Number,t_y:Number):void{
		m__input.p_MouseEvent(t_event,t_data,t_x,t_y);
	}
	public override function TouchEvent(t_event:int,t_data:int,t_x:Number,t_y:Number):void{
		m__input.p_TouchEvent(t_event,t_data,t_x,t_y);
	}
	public override function MotionEvent(t_event:int,t_data:int,t_x:Number,t_y:Number,t_z:Number):void{
		m__input.p_MotionEvent(t_event,t_data,t_x,t_y,t_z);
	}
	public override function DiscardGraphics():void{
		m__graphics.DiscardGraphics();
	}
}
var bb_app__delegate:c_GameDelegate;
var bb_app__game:BBGame;
internal function bbMain():int{
	(new c_MyGame).m_MyGame_new();
	return 0;
}
var bb_graphics_device:gxtkGraphics;
internal function bb_graphics_SetGraphicsDevice(t_dev:gxtkGraphics):int{
	bb_graphics_device=t_dev;
	return 0;
}
class c_Image extends Object{
	internal static var m_DefaultFlags:int;
	public function m_Image_new():c_Image{
		return this;
	}
	internal var m_surface:gxtkSurface=null;
	internal var m_width:int=0;
	internal var m_height:int=0;
	internal var m_frames:Array=[];
	internal var m_flags:int=0;
	internal var m_tx:Number=.0;
	internal var m_ty:Number=.0;
	public function p_SetHandle(t_tx:Number,t_ty:Number):int{
		this.m_tx=t_tx;
		this.m_ty=t_ty;
		this.m_flags=this.m_flags&-2;
		return 0;
	}
	public function p_ApplyFlags(t_iflags:int):int{
		m_flags=t_iflags;
		if((m_flags&2)!=0){
			var t_:Array=m_frames;
			var t_2:int=0;
			while(t_2<t_.length){
				var t_f:c_Frame=t_[t_2];
				t_2=t_2+1;
				t_f.m_x+=1;
			}
			m_width-=2;
		}
		if((m_flags&4)!=0){
			var t_3:Array=m_frames;
			var t_4:int=0;
			while(t_4<t_3.length){
				var t_f2:c_Frame=t_3[t_4];
				t_4=t_4+1;
				t_f2.m_y+=1;
			}
			m_height-=2;
		}
		if((m_flags&1)!=0){
			this.p_SetHandle((m_width)/2.0,(m_height)/2.0);
		}
		if(m_frames.length==1 && m_frames[0].m_x==0 && m_frames[0].m_y==0 && m_width==m_surface.Width() && m_height==m_surface.Height()){
			m_flags|=65536;
		}
		return 0;
	}
	public function p_Init(t_surf:gxtkSurface,t_nframes:int,t_iflags:int):c_Image{
		if((m_surface)!=null){
			error("Image already initialized");
		}
		m_surface=t_surf;
		m_width=((m_surface.Width()/t_nframes)|0);
		m_height=m_surface.Height();
		m_frames=new_object_array(t_nframes);
		for(var t_i:int=0;t_i<t_nframes;t_i=t_i+1){
			m_frames[t_i]=(new c_Frame).m_Frame_new(t_i*m_width,0);
		}
		this.p_ApplyFlags(t_iflags);
		return this;
	}
	internal var m_source:c_Image=null;
	public function p_Init2(t_surf:gxtkSurface,t_x:int,t_y:int,t_iwidth:int,t_iheight:int,t_nframes:int,t_iflags:int,t_src:c_Image,t_srcx:int,t_srcy:int,t_srcw:int,t_srch:int):c_Image{
		if((m_surface)!=null){
			error("Image already initialized");
		}
		m_surface=t_surf;
		m_source=t_src;
		m_width=t_iwidth;
		m_height=t_iheight;
		m_frames=new_object_array(t_nframes);
		var t_ix:int=t_x;
		var t_iy:int=t_y;
		for(var t_i:int=0;t_i<t_nframes;t_i=t_i+1){
			if(t_ix+m_width>t_srcw){
				t_ix=0;
				t_iy+=m_height;
			}
			if(t_ix+m_width>t_srcw || t_iy+m_height>t_srch){
				error("Image frame outside surface");
			}
			m_frames[t_i]=(new c_Frame).m_Frame_new(t_ix+t_srcx,t_iy+t_srcy);
			t_ix+=m_width;
		}
		this.p_ApplyFlags(t_iflags);
		return this;
	}
}
class c_GraphicsContext extends Object{
	public function m_GraphicsContext_new():c_GraphicsContext{
		return this;
	}
	internal var m_defaultFont:c_Image=null;
	internal var m_font:c_Image=null;
	internal var m_firstChar:int=0;
	internal var m_matrixSp:int=0;
	internal var m_ix:Number=1.0;
	internal var m_iy:Number=.0;
	internal var m_jx:Number=.0;
	internal var m_jy:Number=1.0;
	internal var m_tx:Number=.0;
	internal var m_ty:Number=.0;
	internal var m_tformed:int=0;
	internal var m_matDirty:int=0;
	internal var m_color_r:Number=.0;
	internal var m_color_g:Number=.0;
	internal var m_color_b:Number=.0;
	internal var m_alpha:Number=.0;
	internal var m_blend:int=0;
	internal var m_scissor_x:Number=.0;
	internal var m_scissor_y:Number=.0;
	internal var m_scissor_width:Number=.0;
	internal var m_scissor_height:Number=.0;
	public function p_Validate():int{
		if((m_matDirty)!=0){
			bb_graphics_renderDevice.SetMatrix(bb_graphics_context.m_ix,bb_graphics_context.m_iy,bb_graphics_context.m_jx,bb_graphics_context.m_jy,bb_graphics_context.m_tx,bb_graphics_context.m_ty);
			m_matDirty=0;
		}
		return 0;
	}
}
var bb_graphics_context:c_GraphicsContext;
internal function bb_data_FixDataPath(t_path:String):String{
	var t_i:int=t_path.indexOf(":/",0);
	if(t_i!=-1 && t_path.indexOf("/",0)==t_i+1){
		return t_path;
	}
	if(string_startswith(t_path,"./") || string_startswith(t_path,"/")){
		return t_path;
	}
	return "monkey://data/"+t_path;
}
class c_Frame extends Object{
	internal var m_x:int=0;
	internal var m_y:int=0;
	public function m_Frame_new(t_x:int,t_y:int):c_Frame{
		this.m_x=t_x;
		this.m_y=t_y;
		return this;
	}
	public function m_Frame_new2():c_Frame{
		return this;
	}
}
internal function bb_graphics_LoadImage(t_path:String,t_frameCount:int,t_flags:int):c_Image{
	var t_surf:gxtkSurface=bb_graphics_device.LoadSurface(bb_data_FixDataPath(t_path));
	if((t_surf)!=null){
		return ((new c_Image).m_Image_new()).p_Init(t_surf,t_frameCount,t_flags);
	}
	return null;
}
internal function bb_graphics_LoadImage2(t_path:String,t_frameWidth:int,t_frameHeight:int,t_frameCount:int,t_flags:int):c_Image{
	var t_surf:gxtkSurface=bb_graphics_device.LoadSurface(bb_data_FixDataPath(t_path));
	if((t_surf)!=null){
		return ((new c_Image).m_Image_new()).p_Init2(t_surf,0,0,t_frameWidth,t_frameHeight,t_frameCount,t_flags,null,0,0,t_surf.Width(),t_surf.Height());
	}
	return null;
}
internal function bb_graphics_SetFont(t_font:c_Image,t_firstChar:int):int{
	if(!((t_font)!=null)){
		if(!((bb_graphics_context.m_defaultFont)!=null)){
			bb_graphics_context.m_defaultFont=bb_graphics_LoadImage("mojo_font.png",96,2);
		}
		t_font=bb_graphics_context.m_defaultFont;
		t_firstChar=32;
	}
	bb_graphics_context.m_font=t_font;
	bb_graphics_context.m_firstChar=t_firstChar;
	return 0;
}
var bb_audio_device:gxtkAudio;
internal function bb_audio_SetAudioDevice(t_dev:gxtkAudio):int{
	bb_audio_device=t_dev;
	return 0;
}
class c_InputDevice extends Object{
	internal var m__joyStates:Array=new_object_array(4);
	public function m_InputDevice_new():c_InputDevice{
		for(var t_i:int=0;t_i<4;t_i=t_i+1){
			m__joyStates[t_i]=(new c_JoyState).m_JoyState_new();
		}
		return this;
	}
	internal var m__keyDown:Array=new_bool_array(512);
	internal var m__keyHitPut:int=0;
	internal var m__keyHitQueue:Array=new_number_array(33);
	internal var m__keyHit:Array=new_number_array(512);
	public function p_PutKeyHit(t_key:int):void{
		if(m__keyHitPut==m__keyHitQueue.length){
			return;
		}
		m__keyHit[t_key]+=1;
		m__keyHitQueue[m__keyHitPut]=t_key;
		m__keyHitPut+=1;
	}
	public function p_BeginUpdate():void{
		for(var t_i:int=0;t_i<4;t_i=t_i+1){
			var t_state:c_JoyState=m__joyStates[t_i];
			if(!BBGame.Game().PollJoystick(t_i,t_state.m_joyx,t_state.m_joyy,t_state.m_joyz,t_state.m_buttons)){
				break;
			}
			for(var t_j:int=0;t_j<32;t_j=t_j+1){
				var t_key:int=256+t_i*32+t_j;
				if(t_state.m_buttons[t_j]){
					if(!m__keyDown[t_key]){
						m__keyDown[t_key]=true;
						this.p_PutKeyHit(t_key);
					}
				}else{
					m__keyDown[t_key]=false;
				}
			}
		}
	}
	internal var m__charGet:int=0;
	internal var m__charPut:int=0;
	public function p_EndUpdate():void{
		for(var t_i:int=0;t_i<m__keyHitPut;t_i=t_i+1){
			m__keyHit[m__keyHitQueue[t_i]]=0;
		}
		m__keyHitPut=0;
		m__charGet=0;
		m__charPut=0;
	}
	internal var m__charQueue:Array=new_number_array(32);
	public function p_KeyEvent(t_event:int,t_data:int):void{
		var t_1:int=t_event;
		if(t_1==1){
			if(!m__keyDown[t_data]){
				m__keyDown[t_data]=true;
				this.p_PutKeyHit(t_data);
				if(t_data==1){
					m__keyDown[384]=true;
					this.p_PutKeyHit(384);
				}else{
					if(t_data==384){
						m__keyDown[1]=true;
						this.p_PutKeyHit(1);
					}
				}
			}
		}else{
			if(t_1==2){
				if(m__keyDown[t_data]){
					m__keyDown[t_data]=false;
					if(t_data==1){
						m__keyDown[384]=false;
					}else{
						if(t_data==384){
							m__keyDown[1]=false;
						}
					}
				}
			}else{
				if(t_1==3){
					if(m__charPut<m__charQueue.length){
						m__charQueue[m__charPut]=t_data;
						m__charPut+=1;
					}
				}
			}
		}
	}
	internal var m__mouseX:Number=.0;
	internal var m__mouseY:Number=.0;
	internal var m__touchX:Array=new_number_array(32);
	internal var m__touchY:Array=new_number_array(32);
	public function p_MouseEvent(t_event:int,t_data:int,t_x:Number,t_y:Number):void{
		var t_2:int=t_event;
		if(t_2==4){
			this.p_KeyEvent(1,1+t_data);
		}else{
			if(t_2==5){
				this.p_KeyEvent(2,1+t_data);
				return;
			}else{
				if(t_2==6){
				}else{
					return;
				}
			}
		}
		m__mouseX=t_x;
		m__mouseY=t_y;
		m__touchX[0]=t_x;
		m__touchY[0]=t_y;
	}
	public function p_TouchEvent(t_event:int,t_data:int,t_x:Number,t_y:Number):void{
		var t_3:int=t_event;
		if(t_3==7){
			this.p_KeyEvent(1,384+t_data);
		}else{
			if(t_3==8){
				this.p_KeyEvent(2,384+t_data);
				return;
			}else{
				if(t_3==9){
				}else{
					return;
				}
			}
		}
		m__touchX[t_data]=t_x;
		m__touchY[t_data]=t_y;
		if(t_data==0){
			m__mouseX=t_x;
			m__mouseY=t_y;
		}
	}
	internal var m__accelX:Number=.0;
	internal var m__accelY:Number=.0;
	internal var m__accelZ:Number=.0;
	public function p_MotionEvent(t_event:int,t_data:int,t_x:Number,t_y:Number,t_z:Number):void{
		var t_4:int=t_event;
		if(t_4==10){
		}else{
			return;
		}
		m__accelX=t_x;
		m__accelY=t_y;
		m__accelZ=t_z;
	}
}
class c_JoyState extends Object{
	public function m_JoyState_new():c_JoyState{
		return this;
	}
	internal var m_joyx:Array=new_number_array(2);
	internal var m_joyy:Array=new_number_array(2);
	internal var m_joyz:Array=new_number_array(2);
	internal var m_buttons:Array=new_bool_array(32);
}
var bb_input_device:c_InputDevice;
internal function bb_input_SetInputDevice(t_dev:c_InputDevice):int{
	bb_input_device=t_dev;
	return 0;
}
var bb_app__devWidth:int;
var bb_app__devHeight:int;
internal function bb_app_ValidateDeviceWindow(t_notifyApp:Boolean):void{
	var t_w:int=bb_app__game.GetDeviceWidth();
	var t_h:int=bb_app__game.GetDeviceHeight();
	if(t_w==bb_app__devWidth && t_h==bb_app__devHeight){
		return;
	}
	bb_app__devWidth=t_w;
	bb_app__devHeight=t_h;
	if(t_notifyApp){
		bb_app__app.p_OnResize();
	}
}
class c_DisplayMode extends Object{
	internal var m__width:int=0;
	internal var m__height:int=0;
	public function m_DisplayMode_new(t_width:int,t_height:int):c_DisplayMode{
		m__width=t_width;
		m__height=t_height;
		return this;
	}
	public function m_DisplayMode_new2():c_DisplayMode{
		return this;
	}
}
class c_Map extends Object{
	public function m_Map_new():c_Map{
		return this;
	}
	internal var m_root:c_Node=null;
	public function p_Compare(t_lhs:int,t_rhs:int):int{
		return 0;
	}
	public function p_FindNode(t_key:int):c_Node{
		var t_node:c_Node=m_root;
		while((t_node)!=null){
			var t_cmp:int=this.p_Compare(t_key,t_node.m_key);
			if(t_cmp>0){
				t_node=t_node.m_right;
			}else{
				if(t_cmp<0){
					t_node=t_node.m_left;
				}else{
					return t_node;
				}
			}
		}
		return t_node;
	}
	public function p_Contains(t_key:int):Boolean{
		return this.p_FindNode(t_key)!=null;
	}
	public function p_RotateLeft(t_node:c_Node):int{
		var t_child:c_Node=t_node.m_right;
		t_node.m_right=t_child.m_left;
		if((t_child.m_left)!=null){
			t_child.m_left.m_parent=t_node;
		}
		t_child.m_parent=t_node.m_parent;
		if((t_node.m_parent)!=null){
			if(t_node==t_node.m_parent.m_left){
				t_node.m_parent.m_left=t_child;
			}else{
				t_node.m_parent.m_right=t_child;
			}
		}else{
			m_root=t_child;
		}
		t_child.m_left=t_node;
		t_node.m_parent=t_child;
		return 0;
	}
	public function p_RotateRight(t_node:c_Node):int{
		var t_child:c_Node=t_node.m_left;
		t_node.m_left=t_child.m_right;
		if((t_child.m_right)!=null){
			t_child.m_right.m_parent=t_node;
		}
		t_child.m_parent=t_node.m_parent;
		if((t_node.m_parent)!=null){
			if(t_node==t_node.m_parent.m_right){
				t_node.m_parent.m_right=t_child;
			}else{
				t_node.m_parent.m_left=t_child;
			}
		}else{
			m_root=t_child;
		}
		t_child.m_right=t_node;
		t_node.m_parent=t_child;
		return 0;
	}
	public function p_InsertFixup(t_node:c_Node):int{
		while(((t_node.m_parent)!=null) && t_node.m_parent.m_color==-1 && ((t_node.m_parent.m_parent)!=null)){
			if(t_node.m_parent==t_node.m_parent.m_parent.m_left){
				var t_uncle:c_Node=t_node.m_parent.m_parent.m_right;
				if(((t_uncle)!=null) && t_uncle.m_color==-1){
					t_node.m_parent.m_color=1;
					t_uncle.m_color=1;
					t_uncle.m_parent.m_color=-1;
					t_node=t_uncle.m_parent;
				}else{
					if(t_node==t_node.m_parent.m_right){
						t_node=t_node.m_parent;
						this.p_RotateLeft(t_node);
					}
					t_node.m_parent.m_color=1;
					t_node.m_parent.m_parent.m_color=-1;
					this.p_RotateRight(t_node.m_parent.m_parent);
				}
			}else{
				var t_uncle2:c_Node=t_node.m_parent.m_parent.m_left;
				if(((t_uncle2)!=null) && t_uncle2.m_color==-1){
					t_node.m_parent.m_color=1;
					t_uncle2.m_color=1;
					t_uncle2.m_parent.m_color=-1;
					t_node=t_uncle2.m_parent;
				}else{
					if(t_node==t_node.m_parent.m_left){
						t_node=t_node.m_parent;
						this.p_RotateRight(t_node);
					}
					t_node.m_parent.m_color=1;
					t_node.m_parent.m_parent.m_color=-1;
					this.p_RotateLeft(t_node.m_parent.m_parent);
				}
			}
		}
		m_root.m_color=1;
		return 0;
	}
	public function p_Set(t_key:int,t_value:c_DisplayMode):Boolean{
		var t_node:c_Node=m_root;
		var t_parent:c_Node=null;
		var t_cmp:int=0;
		while((t_node)!=null){
			t_parent=t_node;
			t_cmp=this.p_Compare(t_key,t_node.m_key);
			if(t_cmp>0){
				t_node=t_node.m_right;
			}else{
				if(t_cmp<0){
					t_node=t_node.m_left;
				}else{
					t_node.m_value=t_value;
					return false;
				}
			}
		}
		t_node=(new c_Node).m_Node_new(t_key,t_value,-1,t_parent);
		if((t_parent)!=null){
			if(t_cmp>0){
				t_parent.m_right=t_node;
			}else{
				t_parent.m_left=t_node;
			}
			this.p_InsertFixup(t_node);
		}else{
			m_root=t_node;
		}
		return true;
	}
	public function p_Insert(t_key:int,t_value:c_DisplayMode):Boolean{
		return this.p_Set(t_key,t_value);
	}
}
class c_IntMap extends c_Map{
	public function m_IntMap_new():c_IntMap{
		super.m_Map_new();
		return this;
	}
	public override function p_Compare(t_lhs:int,t_rhs:int):int{
		return t_lhs-t_rhs;
	}
}
class c_Stack extends Object{
	public function m_Stack_new():c_Stack{
		return this;
	}
	internal var m_data:Array=[];
	internal var m_length:int=0;
	public function m_Stack_new2(t_data:Array):c_Stack{
		this.m_data=t_data.slice(0);
		this.m_length=t_data.length;
		return this;
	}
	public function p_Push(t_value:c_DisplayMode):void{
		if(m_length==m_data.length){
			m_data=resize_object_array(m_data,m_length*2+10);
		}
		m_data[m_length]=t_value;
		m_length+=1;
	}
	public function p_Push2(t_values:Array,t_offset:int,t_count:int):void{
		for(var t_i:int=0;t_i<t_count;t_i=t_i+1){
			this.p_Push(t_values[t_offset+t_i]);
		}
	}
	public function p_Push3(t_values:Array,t_offset:int):void{
		this.p_Push2(t_values,t_offset,t_values.length-t_offset);
	}
	public function p_ToArray():Array{
		var t_t:Array=new_object_array(m_length);
		for(var t_i:int=0;t_i<m_length;t_i=t_i+1){
			t_t[t_i]=m_data[t_i];
		}
		return t_t;
	}
}
class c_Node extends Object{
	internal var m_key:int=0;
	internal var m_right:c_Node=null;
	internal var m_left:c_Node=null;
	internal var m_value:c_DisplayMode=null;
	internal var m_color:int=0;
	internal var m_parent:c_Node=null;
	public function m_Node_new(t_key:int,t_value:c_DisplayMode,t_color:int,t_parent:c_Node):c_Node{
		this.m_key=t_key;
		this.m_value=t_value;
		this.m_color=t_color;
		this.m_parent=t_parent;
		return this;
	}
	public function m_Node_new2():c_Node{
		return this;
	}
}
var bb_app__displayModes:Array;
var bb_app__desktopMode:c_DisplayMode;
internal function bb_app_DeviceWidth():int{
	return bb_app__devWidth;
}
internal function bb_app_DeviceHeight():int{
	return bb_app__devHeight;
}
internal function bb_app_EnumDisplayModes():void{
	var t_modes:Array=bb_app__game.GetDisplayModes();
	var t_mmap:c_IntMap=(new c_IntMap).m_IntMap_new();
	var t_mstack:c_Stack=(new c_Stack).m_Stack_new();
	for(var t_i:int=0;t_i<t_modes.length;t_i=t_i+1){
		var t_w:int=t_modes[t_i].width;
		var t_h:int=t_modes[t_i].height;
		var t_size:int=t_w<<16|t_h;
		if(t_mmap.p_Contains(t_size)){
		}else{
			var t_mode:c_DisplayMode=(new c_DisplayMode).m_DisplayMode_new(t_modes[t_i].width,t_modes[t_i].height);
			t_mmap.p_Insert(t_size,t_mode);
			t_mstack.p_Push(t_mode);
		}
	}
	bb_app__displayModes=t_mstack.p_ToArray();
	var t_mode2:BBDisplayMode=bb_app__game.GetDesktopMode();
	if((t_mode2)!=null){
		bb_app__desktopMode=(new c_DisplayMode).m_DisplayMode_new(t_mode2.width,t_mode2.height);
	}else{
		bb_app__desktopMode=(new c_DisplayMode).m_DisplayMode_new(bb_app_DeviceWidth(),bb_app_DeviceHeight());
	}
}
var bb_graphics_renderDevice:gxtkGraphics;
internal function bb_graphics_SetMatrix(t_ix:Number,t_iy:Number,t_jx:Number,t_jy:Number,t_tx:Number,t_ty:Number):int{
	bb_graphics_context.m_ix=t_ix;
	bb_graphics_context.m_iy=t_iy;
	bb_graphics_context.m_jx=t_jx;
	bb_graphics_context.m_jy=t_jy;
	bb_graphics_context.m_tx=t_tx;
	bb_graphics_context.m_ty=t_ty;
	bb_graphics_context.m_tformed=((t_ix!=1.0 || t_iy!=0.0 || t_jx!=0.0 || t_jy!=1.0 || t_tx!=0.0 || t_ty!=0.0)?1:0);
	bb_graphics_context.m_matDirty=1;
	return 0;
}
internal function bb_graphics_SetMatrix2(t_m:Array):int{
	bb_graphics_SetMatrix(t_m[0],t_m[1],t_m[2],t_m[3],t_m[4],t_m[5]);
	return 0;
}
internal function bb_graphics_SetColor(t_r:Number,t_g:Number,t_b:Number):int{
	bb_graphics_context.m_color_r=t_r;
	bb_graphics_context.m_color_g=t_g;
	bb_graphics_context.m_color_b=t_b;
	bb_graphics_renderDevice.SetColor(t_r,t_g,t_b);
	return 0;
}
internal function bb_graphics_SetAlpha(t_alpha:Number):int{
	bb_graphics_context.m_alpha=t_alpha;
	bb_graphics_renderDevice.SetAlpha(t_alpha);
	return 0;
}
internal function bb_graphics_SetBlend(t_blend:int):int{
	bb_graphics_context.m_blend=t_blend;
	bb_graphics_renderDevice.SetBlend(t_blend);
	return 0;
}
internal function bb_graphics_SetScissor(t_x:Number,t_y:Number,t_width:Number,t_height:Number):int{
	bb_graphics_context.m_scissor_x=t_x;
	bb_graphics_context.m_scissor_y=t_y;
	bb_graphics_context.m_scissor_width=t_width;
	bb_graphics_context.m_scissor_height=t_height;
	bb_graphics_renderDevice.SetScissor(((t_x)|0),((t_y)|0),((t_width)|0),((t_height)|0));
	return 0;
}
internal function bb_graphics_BeginRender():int{
	bb_graphics_renderDevice=bb_graphics_device;
	bb_graphics_context.m_matrixSp=0;
	bb_graphics_SetMatrix(1.0,0.0,0.0,1.0,0.0,0.0);
	bb_graphics_SetColor(255.0,255.0,255.0);
	bb_graphics_SetAlpha(1.0);
	bb_graphics_SetBlend(0);
	bb_graphics_SetScissor(0.0,0.0,(bb_app_DeviceWidth()),(bb_app_DeviceHeight()));
	return 0;
}
internal function bb_graphics_EndRender():int{
	bb_graphics_renderDevice=null;
	return 0;
}
class c_BBGameEvent extends Object{
}
internal function bb_app_EndApp():void{
	error("");
}
var bb_app__updateRate:int;
internal function bb_app_SetUpdateRate(t_hertz:int):void{
	bb_app__updateRate=t_hertz;
	bb_app__game.SetUpdateRate(t_hertz);
}
class c_heightmap extends Object{
	internal var m_w:int=0;
	internal var m_h:int=0;
	internal var m_hmap:Array=[];
	internal var m_fmap:Array=[];
	internal var m_x3:int=0;
	internal var m_y3:int=0;
	internal var m_x4:int=0;
	internal var m_y4:int=0;
	public function p_clearfmap():int{
		for(var t_y:int=0;t_y<m_h;t_y=t_y+1){
			for(var t_x:int=0;t_x<m_w;t_x=t_x+1){
				m_fmap[t_x][t_y]=0;
			}
		}
		return 0;
	}
	public function p_line(t_x1:int,t_y1:int,t_x2:int,t_y2:int):void{
		var t_dx:int=0;
		var t_dy:int=0;
		var t_sx:int=0;
		var t_sy:int=0;
		var t_e:int=0;
		t_dx=bb_math_Abs(t_x2-t_x1);
		t_sx=-1;
		if(t_x1<t_x2){
			t_sx=1;
		}
		t_dy=bb_math_Abs(t_y2-t_y1);
		t_sy=-1;
		if(t_y1<t_y2){
			t_sy=1;
		}
		if(t_dx<t_dy){
			t_e=((t_dx/2)|0);
		}else{
			t_e=((t_dy/2)|0);
		}
		var t_exitloop:Boolean=false;
		while(t_exitloop==false){
			m_fmap[t_x1][t_y1]=1;
			if(t_x1==t_x2){
				if(t_y1==t_y2){
					t_exitloop=true;
				}
			}
			if(t_dx>t_dy){
				t_x1+=t_sx;
				t_e-=t_dy;
				if(t_e<0){
					t_e+=t_dx;
					t_y1+=t_sy;
				}
			}else{
				t_y1+=t_sy;
				t_e-=t_dx;
				if(t_e<0){
					t_e+=t_dy;
					t_x1+=t_sx;
				}
			}
		}
	}
	internal var m_ol:c_List=(new c_List).m_List_new();
	public function p_fillfmap():int{
		var t_exitloop:Boolean=false;
		var t_x1:int=0;
		var t_y1:int=0;
		while(t_exitloop==false){
			t_x1=((bb_random_Rnd3(m_w))|0);
			t_y1=((bb_random_Rnd3(m_h))|0);
			if(m_fmap[t_x1][t_y1]==0){
				t_exitloop=true;
			}
		}
		m_ol.p_Clear();
		m_ol.p_AddLast((new c_openlist).m_openlist_new(t_x1,t_y1));
		m_fmap[t_x1][t_y1]=1;
		while(m_ol.p_IsEmpty()==false){
			var t_:c_Enumerator=m_ol.p_ObjectEnumerator();
			while(t_.p_HasNext()){
				var t_i:c_openlist=t_.p_NextObject();
				var t_tx:int=t_i.m_x;
				var t_ty:int=t_i.m_y;
				if(t_tx-1>-1){
					if(m_fmap[t_tx-1][t_ty]==0){
						m_ol.p_AddLast((new c_openlist).m_openlist_new(t_tx-1,t_ty));
						m_fmap[t_tx-1][t_ty]=1;
					}
				}
				if(t_tx+1<m_w){
					if(m_fmap[t_tx+1][t_ty]==0){
						m_ol.p_AddLast((new c_openlist).m_openlist_new(t_tx+1,t_ty));
						m_fmap[t_tx+1][t_ty]=1;
					}
				}
				if(t_ty-1>-1){
					if(m_fmap[t_tx][t_ty-1]==0){
						m_ol.p_AddLast((new c_openlist).m_openlist_new(t_tx,t_ty-1));
						m_fmap[t_tx][t_ty-1]=1;
					}
				}
				if(t_ty+1<m_h){
					if(m_fmap[t_tx][t_ty+1]==0){
						m_ol.p_AddLast((new c_openlist).m_openlist_new(t_tx,t_ty+1));
						m_fmap[t_tx][t_ty+1]=1;
					}
				}
				m_ol.p_Remove(t_i);
			}
		}
		return 0;
	}
	public function p_addhmap():int{
		for(var t_y:int=0;t_y<m_h;t_y=t_y+1){
			for(var t_x:int=0;t_x<m_w;t_x=t_x+1){
				m_hmap[t_x][t_y]+=m_fmap[t_x][t_y];
			}
		}
		return 0;
	}
	public function p_makeheightmap():int{
		for(var t_i:int=0;t_i<255;t_i=t_i+1){
			var t_startside:int=0;
			var t_endside:int=0;
			var t_exitloop:Boolean=false;
			while(t_exitloop==false){
				t_endside=((bb_random_Rnd2(1.0,5.0))|0);
				t_startside=((bb_random_Rnd2(1.0,5.0))|0);
				if(t_endside!=t_startside){
					t_exitloop=true;
				}
			}
			m_x3=((bb_random_Rnd3(m_w))|0);
			m_y3=((bb_random_Rnd3(m_h))|0);
			m_x4=((bb_random_Rnd3(m_w))|0);
			m_y4=((bb_random_Rnd3(m_h))|0);
			var t_1:int=t_startside;
			if(t_1==1){
				m_y3=0;
			}else{
				if(t_1==2){
					m_x3=m_w-1;
				}else{
					if(t_1==3){
						m_y3=m_h-1;
					}else{
						if(t_1==4){
							m_x3=0;
						}
					}
				}
			}
			var t_2:int=t_endside;
			if(t_2==1){
				m_y4=0;
			}else{
				if(t_2==2){
					m_x4=m_w-1;
				}else{
					if(t_2==3){
						m_y4=m_h-1;
					}else{
						if(t_2==4){
							m_x4=0;
						}
					}
				}
			}
			this.p_clearfmap();
			this.p_line(m_x3,m_y3,m_x4,m_y4);
			this.p_fillfmap();
			this.p_addhmap();
		}
		return 0;
	}
	public function m_heightmap_new(t_w:int,t_h:int):c_heightmap{
		this.m_w=t_w;
		this.m_h=t_h;
		m_hmap=new_array_array(t_w);
		m_fmap=new_array_array(t_w);
		for(var t_i:int=0;t_i<t_w;t_i=t_i+1){
			m_hmap[t_i]=new_number_array(t_h);
			m_fmap[t_i]=new_number_array(t_h);
		}
		this.p_makeheightmap();
		return this;
	}
	public function m_heightmap_new2():c_heightmap{
		return this;
	}
	public function p_draw():int{
		var t_sx:Number=(bb_app_DeviceWidth())/(m_w);
		var t_sy:Number=(bb_app_DeviceHeight())/(m_h);
		for(var t_y:int=0;t_y<m_h;t_y=t_y+1){
			for(var t_x:int=0;t_x<m_w;t_x=t_x+1){
				var t_g:int=m_hmap[t_x][t_y];
				bb_graphics_SetColor((t_g)/1.5,(t_g)/1.5,(t_g));
				bb_graphics_DrawRect((t_x)*t_sx,(t_y)*t_sy,t_sx+1.0,t_sy+1.0);
			}
		}
		return 0;
	}
}
var bb_random_Seed:int;
internal function bb_random_Rnd():Number{
	bb_random_Seed=bb_random_Seed*1664525+1013904223|0;
	return (bb_random_Seed>>8&16777215)/16777216.0;
}
internal function bb_random_Rnd2(t_low:Number,t_high:Number):Number{
	return bb_random_Rnd3(t_high-t_low)+t_low;
}
internal function bb_random_Rnd3(t_range:Number):Number{
	return bb_random_Rnd()*t_range;
}
internal function bb_math_Abs(t_x:int):int{
	if(t_x>=0){
		return t_x;
	}
	return -t_x;
}
internal function bb_math_Abs2(t_x:Number):Number{
	if(t_x>=0.0){
		return t_x;
	}
	return -t_x;
}
class c_openlist extends Object{
	internal var m_x:int=0;
	internal var m_y:int=0;
	public function m_openlist_new(t_x:int,t_y:int):c_openlist{
		this.m_x=t_x;
		this.m_y=t_y;
		return this;
	}
	public function m_openlist_new2():c_openlist{
		return this;
	}
}
class c_List extends Object{
	public function m_List_new():c_List{
		return this;
	}
	internal var m__head:c_Node2=((new c_HeadNode).m_HeadNode_new());
	public function p_AddLast(t_data:c_openlist):c_Node2{
		return (new c_Node2).m_Node_new(m__head,m__head.m__pred,t_data);
	}
	public function m_List_new2(t_data:Array):c_List{
		var t_:Array=t_data;
		var t_2:int=0;
		while(t_2<t_.length){
			var t_t:c_openlist=t_[t_2];
			t_2=t_2+1;
			this.p_AddLast(t_t);
		}
		return this;
	}
	public function p_Clear():int{
		m__head.m__succ=m__head;
		m__head.m__pred=m__head;
		return 0;
	}
	public function p_IsEmpty():Boolean{
		return m__head.m__succ==m__head;
	}
	public function p_ObjectEnumerator():c_Enumerator{
		return (new c_Enumerator).m_Enumerator_new(this);
	}
	public function p_Equals(t_lhs:c_openlist,t_rhs:c_openlist):Boolean{
		return t_lhs==t_rhs;
	}
	public function p_RemoveEach(t_value:c_openlist):int{
		var t_node:c_Node2=m__head.m__succ;
		while(t_node!=m__head){
			var t_succ:c_Node2=t_node.m__succ;
			if(this.p_Equals(t_node.m__data,t_value)){
				t_node.p_Remove2();
			}
			t_node=t_succ;
		}
		return 0;
	}
	public function p_Remove(t_value:c_openlist):void{
		this.p_RemoveEach(t_value);
	}
}
class c_Node2 extends Object{
	internal var m__succ:c_Node2=null;
	internal var m__pred:c_Node2=null;
	internal var m__data:c_openlist=null;
	public function m_Node_new(t_succ:c_Node2,t_pred:c_Node2,t_data:c_openlist):c_Node2{
		m__succ=t_succ;
		m__pred=t_pred;
		m__succ.m__pred=this;
		m__pred.m__succ=this;
		m__data=t_data;
		return this;
	}
	public function m_Node_new2():c_Node2{
		return this;
	}
	public function p_Remove2():int{
		m__succ.m__pred=m__pred;
		m__pred.m__succ=m__succ;
		return 0;
	}
}
class c_HeadNode extends c_Node2{
	public function m_HeadNode_new():c_HeadNode{
		super.m_Node_new2();
		m__succ=(this);
		m__pred=(this);
		return this;
	}
}
class c_Enumerator extends Object{
	internal var m__list:c_List=null;
	internal var m__curr:c_Node2=null;
	public function m_Enumerator_new(t_list:c_List):c_Enumerator{
		m__list=t_list;
		m__curr=t_list.m__head.m__succ;
		return this;
	}
	public function m_Enumerator_new2():c_Enumerator{
		return this;
	}
	public function p_HasNext():Boolean{
		while(m__curr.m__succ.m__pred!=m__curr){
			m__curr=m__curr.m__succ;
		}
		return m__curr!=m__list.m__head;
	}
	public function p_NextObject():c_openlist{
		var t_data:c_openlist=m__curr.m__data;
		m__curr=m__curr.m__succ;
		return t_data;
	}
}
var bb_test1_myhmap:c_heightmap;
internal function bb_graphics_Cls(t_r:Number,t_g:Number,t_b:Number):int{
	bb_graphics_renderDevice.Cls(t_r,t_g,t_b);
	return 0;
}
internal function bb_graphics_DrawRect(t_x:Number,t_y:Number,t_w:Number,t_h:Number):int{
	bb_graphics_context.p_Validate();
	bb_graphics_renderDevice.DrawRect(t_x,t_y,t_w,t_h);
	return 0;
}
function bbInit():void{
	bb_app__app=null;
	bb_app__delegate=null;
	bb_app__game=BBGame.Game();
	bb_graphics_device=null;
	bb_graphics_context=(new c_GraphicsContext).m_GraphicsContext_new();
	c_Image.m_DefaultFlags=0;
	bb_audio_device=null;
	bb_input_device=null;
	bb_app__devWidth=0;
	bb_app__devHeight=0;
	bb_app__displayModes=[];
	bb_app__desktopMode=null;
	bb_graphics_renderDevice=null;
	bb_app__updateRate=0;
	bb_random_Seed=1234;
	bb_test1_myhmap=(new c_heightmap).m_heightmap_new(100,100);
}
//${TRANSCODE_END}
